Imports System.Collections.Generic
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Diagnostics
Imports System.IO
Imports System.Windows.Forms

Class PacDrive
	Public Enum DeviceType
		Unknown
		PacDrive
		UHID
		PacLED64
	End Enum

	Public Enum FlashSpeed As Byte
		AlwaysOn = 0
		Seconds_2 = 1
		Seconds_1 = 2
		Seconds_0_5 = 3
	End Enum

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Sub PacSetCallbacks(pacAttachedCallback As PAC_ATTACHED_CALLBACK, pacRemovedCallback As PAC_REMOVED_CALLBACK)
	End Sub

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function PacInitialize() As Integer
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Sub PacShutdown()
	End Sub

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function PacSetLEDStates(id As Integer, data As UShort) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function PacSetLEDState(id As Integer, port As Integer, <MarshalAs(UnmanagedType.Bool)> state As Boolean) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetLEDStates(id As Integer, group As Integer, data As Byte) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetLEDState(id As Integer, group As Integer, port As Integer, <MarshalAs(UnmanagedType.Bool)> state As Boolean) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetLEDStatesRandom(id As Integer) As Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetLEDIntensities(id As Integer, data As Byte()) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetLEDIntensity(id As Integer, port As Integer, intensity As Byte) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetLEDFadeTime(id As Integer, fadeTime As Byte) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetLEDFlashSpeeds(id As Integer, flashSpeed As Byte) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetLEDFlashSpeed(id As Integer, port As Integer, flashSpeed As Byte) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64StartScriptRecording(id As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64StopScriptRecording(id As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetScriptStepDelay(id As Integer, stepDelay As Byte) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64RunScript(id As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64ClearFlash(id As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function Pac64SetDeviceId(id As Integer, newId As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function PacGetDeviceType(id As Integer) As Integer
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function PacGetVendorId(Id As Integer) As Integer
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function PacGetProductId(Id As Integer) As Integer
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function PacGetVersionNumber(Id As Integer) As Integer
	End Function

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Sub PacGetVendorName(Id As Integer, VendorName As StringBuilder)
	End Sub

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Sub PacGetProductName(Id As Integer, ProductName As StringBuilder)
	End Sub

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Sub PacGetSerialNumber(Id As Integer, SerialNumber As StringBuilder)
	End Sub

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Sub PacGetDevicePath(Id As Integer, DevicePath As StringBuilder)
	End Sub

	<DllImport("PacDrive.dll", CallingConvention := CallingConvention.StdCall)> _
	Private Shared Function PacProgramUHid(id As Integer, FileName As StringBuilder) As <MarshalAs(UnmanagedType.Bool)> Boolean
	End Function

	Private Delegate Sub PAC_ATTACHED_CALLBACK(id As Integer)
	Private Delegate Sub PAC_REMOVED_CALLBACK(id As Integer)

	Public Delegate Sub PacAttachedDelegate(id As Integer)
	Public Delegate Sub PacRemovedDelegate(id As Integer)

    Public Event OnPacAttached As PacAttachedDelegate
    Public Event OnPacRemoved As PacRemovedDelegate

	<MarshalAs(UnmanagedType.FunctionPtr)> _
	Private PacAttachedCallbackPtr As PAC_ATTACHED_CALLBACK = Nothing

	<MarshalAs(UnmanagedType.FunctionPtr)> _
	Private PacRemovedCallbackPtr As PAC_REMOVED_CALLBACK = Nothing

	Private m_ctrl As Control
	Private m_numDevices As Integer = 0

	Public Sub New(ctrl As Control)
		m_ctrl = ctrl

		PacAttachedCallbackPtr = New PAC_ATTACHED_CALLBACK(AddressOf PacAttachedCallback)
		PacRemovedCallbackPtr = New PAC_REMOVED_CALLBACK(AddressOf PacRemovedCallback)

		PacSetCallbacks(PacAttachedCallbackPtr, PacRemovedCallbackPtr)
	End Sub

	Private Sub PacAttachedCallback(id As Integer)
		m_numDevices += 1

        RaiseEvent OnPacAttached(id)
	End Sub

	Private Sub PacRemovedCallback(id As Integer)
		m_numDevices -= 1

        RaiseEvent OnPacRemoved(id)
	End Sub

	Public Function Initialize() As Integer
		m_numDevices = PacInitialize()

		Return m_numDevices
	End Function

	Public Sub Shutdown()
		PacShutdown()
	End Sub

	Public Function SetLEDStates(Id As Integer, Data As UShort) As Boolean
		Return PacSetLEDStates(Id, Data)
	End Function

	Public Function SetLEDState(Id As Integer, Port As Integer, State As Boolean) As Boolean
		Return PacSetLEDState(Id, Port, State)
	End Function

	Public Function SetLEDStates(Id As Integer, Data As Boolean()) As Boolean
		Dim dataSend As UShort = 0

		For i As Integer = 0 To Data.Length - 1
			If Data(i) Then
				dataSend = dataSend Or CUShort(1 << i)
			End If
		Next

		Return PacSetLEDStates(Id, dataSend)
	End Function

	Public Function SetLED64States(Id As Integer, Group As Integer, Data As Byte) As Boolean
		Return Pac64SetLEDStates(Id, Group, Data)
	End Function

	Public Function SetLED64States(Id As Integer, Group As Integer, Data As Boolean()) As Boolean
		Dim dataSend As Byte = 0

		For i As Integer = 0 To Data.Length - 1
			If Data(i) Then
				dataSend = dataSend Or CByte(1 << i)
			End If
		Next

		Return Pac64SetLEDStates(Id, Group, dataSend)
	End Function

	Public Function SetLED64StatesRandom(Id As Integer) As Boolean
		Return Pac64SetLEDStatesRandom(Id)
	End Function

	Public Function SetLED64Intensities(Id As Integer, Data As Byte()) As Boolean
		Return Pac64SetLEDIntensities(Id, Data)
	End Function

	Public Function SetLED64Intensity(Id As Integer, Port As Integer, Intensity As Byte) As Boolean
		Return Pac64SetLEDIntensity(Id, Port, Intensity)
	End Function

	Public Function SetLED64FadeTime(Id As Integer, FadeTime As Byte) As Boolean
		Return Pac64SetLEDFadeTime(Id, FadeTime)
	End Function

	Public Function SetLED64FlashSpeeds(Id As Integer, FlashSpeed As FlashSpeed) As Boolean
		Return Pac64SetLEDFlashSpeeds(Id, CByte(FlashSpeed))
	End Function

	Public Function SetLED64FlashSpeed(Id As Integer, Port As Integer, FlashSpeed As FlashSpeed) As Boolean
		Return Pac64SetLEDFlashSpeed(Id, Port, CByte(FlashSpeed))
	End Function

	Public Function StartScriptRecording(Id As Integer) As Boolean
		Return Pac64StartScriptRecording(Id)
	End Function

	Public Function StopScriptRecording(Id As Integer) As Boolean
		Return Pac64StopScriptRecording(Id)
	End Function

	Public Function SetScriptStepDelay(Id As Integer, StepDelay As Byte) As Boolean
		Return Pac64SetScriptStepDelay(Id, StepDelay)
	End Function

	Public Function RunScript(Id As Integer) As Boolean
		Return Pac64RunScript(Id)
	End Function

	Public Function ClearFlash(Id As Integer) As Boolean
		Return Pac64ClearFlash(Id)
	End Function

	Public Function SetDeviceId(Id As Integer, NewId As Integer) As Boolean
		Return Pac64SetDeviceId(Id, NewId)
	End Function

	Public Function GetDeviceType(Id As Integer) As DeviceType
		Return CType(PacGetDeviceType(Id), DeviceType)
	End Function

	Public Function GetVendorId(Id As Integer) As Integer
		Return PacGetVendorId(Id)
	End Function

	Public Function GetProductId(Id As Integer) As Integer
		Return PacGetProductId(Id)
	End Function

	Public Function GetVersionNumber(Id As Integer) As Integer
		Return PacGetVersionNumber(Id)
	End Function

	Public Function GetVendorName(Id As Integer) As String
		Dim sb As New StringBuilder(256)

		PacGetVendorName(Id, sb)

		Return sb.ToString()
	End Function

	Public Function GetProductName(Id As Integer) As String
		Dim sb As New StringBuilder(256)

		PacGetProductName(Id, sb)

		Return sb.ToString()
	End Function

	Public Function GetSerialNumber(Id As Integer) As String
		Dim sb As New StringBuilder(256)

		PacGetSerialNumber(Id, sb)

		Return sb.ToString()
	End Function

	Public Function GetDevicePath(Id As Integer) As String
		Dim sb As New StringBuilder(256)

		PacGetDevicePath(Id, sb)

		Return sb.ToString()
	End Function

	Public Function ProgramUHid(Id As Integer, FileName As String) As Boolean
		Dim sb As New StringBuilder(FileName)

		Return PacProgramUHid(Id, sb)
	End Function

	Public ReadOnly Property NumDevices() As Integer
		Get
			Return m_numDevices
		End Get
	End Property
End Class
